/*****************************************************************/
/* FILE:        	fmtvars.inc                              */
/* PROJECT: 		Healthy, Wealthy, & Wise (AHEAD Data)    */
/* FACULTY:		Dan McFadden                             */
/* AUTHOR:		Tiago Ribeiro                            */
/* LAST UPDATE:		Jan 2003                                 */
/* PROGRAM DESC:	Code formats for some demog vars         */
/* CONTACT:             tribeiro@econ.berkeley.edu               */
/*****************************************************************/

proc format lib=formats;

value sstype1f
1='Retirement'
2='Survivors'
3='Disability'
4='Dependent'
7='Other';

value numassf
0='0'
1='1'
2='2'
3-4='3-4'
5-7='5-7'
8-10='8-10';

value pctform
      0='    0%'
.01-.20=' 1-20%'
.21-.40='21-40%'
.41-.60='41-60%'
.61-.80='61-80%'
.81-1.0='81-100%';

value agefm
0-64='< 65'
65-69='65-69'
70-74='70-74'
75-79='75-79'
80-84='80-84'
85-89='85-89'
90-150='90+'
;

value age2f
0-69='< 70'
70-74='70-74'
75-79='75-79'
80-84='80-84'
85-high='85 +'
;

value sexfm
1='male'
2='female';

value quintf
1='quintile 1'
2='quintile 2'
3='quintile 3'
4='quintile 4'
5='quintile 5';

value ssform
.0000000000-.20='.00 - .20'
.2000000001-.40='.21 - .40'
.4000000001-.60='.41 - .60'
.6000000001-.80='.61 - .80'
.8000000001-1.0='.81 - 1.0';

value healthfm
1="EX"
2="VG"
3="GD"
4="FR"
5="PR";


value healthld
1='Yes, Resp only'
2='Yes, Both'
3='Yes, Spouse only'
5='No';

value healthnc
1='Yes'
5='No'
7='Not Settled';

value l_ssfm
1='Yes, both'
2='Yes, Just R'
3='Yes, Just Spouse'
5='No';

value marstatf
1-3="married"
4="divorced/sep"
5="widowed"
6="never married";

run;








