/*****************************************************************/
/* FILE:        	impcat2.sas                              */
/* PROJECT: 		Healthy, Wealthy, & Wise (AHEAD Data)    */
/* FACULTY:		Dan McFadden                             */
/* AUTHOR:		Tiago Ribeiro                            */
/* LAST UPDATE:		Jan 2003                                 */
/* PROGRAM DESC:	Categorical asset imputation wave 2      */
/* CONTACT:             tribeiro@econ.berkeley.edu               */
/*****************************************************************/

data w2assets;
    set local8.w2assets;
run;

%merge(w2assets,w2assets,wv2,hhid dsubhh,1);
data tmp;
    set local8.w1astc;
    keep hhid nhhbppn;
    keep %list2_4(cn,1,2);;
    keep hcond1 nhood1 cntinc1;
run;
%merge(w2assets,w2assets,tmp,hhid,1);

    
%let cntrlv=nhhbppn nhhdppn cnhous1 cnstck1 cnchck1;

%let seed=12;
%let impv =c_hous2;
%let impvn=cnhous2;
%let mapd=asstcat.c_hous2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=13;
%let impv = c_stck2;
%let impvn= cnstck2;
%let mapd= asstcat.c_stck2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=14;
%let impv = c_chck2;
%let impvn= cnchck2;
%let mapd= asstcat.c_chck2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=15;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cnrlst1;
%let impv = c_rlst2;
%let impvn= cnrlst2;
%let mapd= asstcat.c_rlst2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=16;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cntrns1;
%let impv =c_trns2;
%let impvn=cntrns2;
%let mapd=asstcat.c_trns2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=17;
%let cntrlv=nhhbppn nhhdppn cnchck1 cnira1;
%let impv =c_ira12;
%let impvn=cnira12;
%let mapd=asstcat.c_ira12;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=18;
%let cntrlv=nhhbppn nhhdppn cnira12;
%let impv =c_ira22;
%let impvn=cnira22;
%let mapd=asstcat.c_ira22;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=19;
%let cntrlv= nhhbppn  nhhdppn cnira12;
%let impv =c_ira32;
%let impvn=cnira32;
%let mapd=asstcat.c_ira32;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=20;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cnbsns1;
%let impv =c_bsns2;
%let impvn=cnbsns2;
%let mapd=asstcat.c_bsns2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=21;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cncd1;
%let impv =c_cd2;
%let impvn=cncd2;
%let mapd=asstcat.c_cd2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=22;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cnbond1;
%let impv =c_bond2;
%let impvn=cnbond2;
%let mapd=asstcat.c_bond2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=23;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cnothr1;
%let impv =c_othr2;
%let impvn=cnothr2;
%let mapd=asstcat.c_othr2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=24;
%let cntrlv=nhhbppn nhhdppn cnhous1  cnchck1 cndebt1;
%let impv =c_debt2;
%let impvn=cndebt2;
%let mapd=asstcat.c_debt2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);


%let seed=25;
%let cntrlv=nhhbppn nhhdppn cnchck1 cnmobh1 cnmort1;
%let impv =c_mobh2 c_mort2 c_2mrt2 c_loan2;
%let impvn=cnmobh2 cnmort2 cn2mrt2 cnloan2;
%let mapd=asstcat.c_mobh2 asstcat.c_mort2 asstcat.c_2mrt2 asstcat.c_loan2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let seed=26;
%let cntrlv=nhhbppn nhhdppn cntinc1;
%let impv =c_tinc2;
%let impvn=cntinc2;
%let mapd=asstcat.c_tinc2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);


data map1;
    input v1 v2 v3 v4 v5 hcond2;
    cards;
        1 0 0 0 0 1
        0 1 0 0 0 2
        0 0 1 0 0 3
        0 0 0 1 0 4
        0 0 0 0 1 5
        1 1 1 1 1 6
            ;
run;

data map2;
    input v1 v2 v3 v4 v5 nhood2;
    cards;
        1 0 0 0 0 1
        0 1 0 0 0 2
        0 0 1 0 0 3
        0 0 0 1 0 4
        0 0 0 0 1 5
        1 1 1 1 1 6
            ;
run;

data w2assets;
    set w2assets;
    if hcond2 in(.,7,8,9) then hcond2=6;
    if nhood2 in(.,7,8,9) then nhood2=6;
run;

proc freq; tables hcond2 nhood2; run;
%let seed=27;
%let cntrlv=nhhbppn  hcond1 nhood1;
%let impv  =hcond2  nhood2;
%let impvn=nhcond2 nnhood2;
%let mapd=map1 map2;
%impcat(w2assets,&impv,&impvn,&mapd,&cntrlv,&seed);

%let cvars=%list2_4(cn,2,1);;
%let dvars=%list2_4(dn,2,1);;
      
data local8.w2astc;
    set w2assets;
    array cn{*} &cvars;
    array dn{*} &dvars;
    do i=1 to dim(cn);
        dn{i}=(cn{i}>0);
        end;
    drop i;
    drop nhhbppn;
    drop %list2_4(cn,1,2);;
    drop hcond1 nhood1 cntinc1;

    nhood2=nnhood2;
    hcond2=nhcond2;
    drop nnhood2 nhcond2;

    hoodex2=(nhood2=1);
    hoodvg2=(nhood2=2);
    hoodgd2=(nhood2=3);
    hoodfr2=(nhood2=4);
    hoodpr2=(nhood2=5);

    condex2=(hcond2=1);
    condvg2=(hcond2=2);
    condgd2=(hcond2=3);
    condfr2=(hcond2=4);
    condpr2=(hcond2=5);

   %labeli(cn,rlst,w2);
   %labeli(cn,bsns,w2);
   *%labeli(cn,ira,w2);
   %labeli(cn,ira1,w2);
   %labeli(cn,ira2,w2);
   %labeli(cn,ira3,w2);
   %labeli(cn,stck,w2);
   %labeli(cn,bond,w2);
   %labeli(cn,chck,w2);
   %labeli(cn,cd,w2);
   %labeli(cn,othr,w2);
   %labeli(cn,trns,w2);
   %labeli(cn,debt,w2);
   %labeli(cn,mobh,w2);
   %labeli(cn,hous,w2);
   %labeli(cn,mort,w2);
   %labeli(cn,2mrt,w2);
   %labeli(cn,loan,w2);
   %labeli(cn,tinc,w2);

run;
proc means; var &dvars; run;


